unit Dagtest;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DAG, StdCtrls, ExtCtrls, Menus;

type
  TfrmDAGViewTest = class(TForm)
    pnlScroller: TPanel;
    pupDAGView: TPopupMenu;
    pitDelete: TMenuItem;
    pitColor: TMenuItem;
    dlgColor: TColorDialog;
    pnlPrototypes: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnMakeFreeEdgeClick(Sender: TObject);
    procedure AdjustNodeColor(Sender: TObject);
    procedure ClearAll(Sender: TObject);
  private
	FDAGView		: TDAGView;
  public
    { Public declarations }
  end;

var
  frmDAGViewTest: TfrmDAGViewTest;

implementation

{$R *.DFM}

function PrototypeColor( iNode : integer ) : TColor;
begin
	case iNode of
    	0 : Result := clRed;
    	1 : Result := clYellow;
    	2 : Result := clBlack;
    	3 : Result := clAqua;
         else
         	raise Exception.CreateFmt( 'Invalid prototype #: %d', [iNode] );
    end;
end;

procedure TfrmDAGViewTest.FormCreate(Sender: TObject);

var
    iNode	: integer;
    node		: TDAGNode;

begin

    FDAGView := TDAGView.Create( self );
    with FDAGView do
    begin
    	Parent := pnlScroller;
         Align  := alClient;
    end;

    for iNode := 0 to 3 do
    begin
    	node := TDAGNode.Create( self );

         with node do
         begin
         	Parent 		:= pnlPrototypes;
              Top			:=	5;
              Left			:= 5 + ( iNode * ( DAGNodeRadius * 2 + 5 ) );
              BrushColor     := PrototypeColor( iNode );
         end;
    end;
end;

procedure TfrmDAGViewTest.btnMakeFreeEdgeClick(Sender: TObject);
var
	edge :           TDAGEdge;
begin
	edge := TDAGEdge.Create( self );
    edge.Parent := Self;
    edge.Height := 100;
    edge.Width := 100;
    edge.Left := 10;
    edge.Top := 10;
    FDAGView.AddEdge( edge );
end;

procedure TfrmDAGViewTest.AdjustNodeColor(Sender: TObject);
begin
	if dlgColor.Execute then with FDAGView do
    	if SelNode <> Nil then
    		SelNode.BrushColor := dlgColor.Color;
end;

procedure TfrmDAGViewTest.ClearAll(Sender: TObject);
begin
	FDAGView.ClearAll;
end;

end.
